import java.io.*;
import java.util.*;

// AFύXȂǂ̃R}hACeNX
class ukMelodyCommand {

	public static final byte COMMAND_NONE = 0;
	public static final byte COMMAND_NOTE = 1;
	public static final byte COMMAND_REST = 2;
	public static final byte COMMAND_PROG = 4;
	public static final byte COMMAND_PANPOT = 5;
	public static final byte COMMAND_VOL = 6;
	public static final byte COMMAND_VELOCITY = 7;
	public static final byte COMMAND_MASTER_VOL = 8;
	public static final byte COMMAND_TEMPO = 9;

	private int _time;

	private byte _channel;
	private byte _command;

	private short _length;

	private short[] _param = new short[4];

	public ukMelodyCommand() {

	}

	/**
	Rs[RXgN^
	*/
	public ukMelodyCommand(ukMelodyCommand src) {
		assign(src);
	}

	public void assign(ukMelodyCommand src) {

		_time = src._time;

		_channel = src._channel;

		_command = src._command;

		_length = src._length;

		for (int i = 0;i < _param.length;i++) {
			_param[i] = src._param[i];
		}

	}

	/**
	R}h쐬
	@param no m[gԍ
	@param velocity xVeB
	@param length Ŝ̒
	@param @noteLength 

	@return 쐬ꂽR}hBsnull
	*/
	static ukMelodyCommand createNoteItem(int no, int velocity, int length, int noteLength) {

		if (no < 0 || no > 127 || velocity < 0 || velocity > 127 || length < 1 || noteLength < 1 || length < noteLength) {
			return null;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item._command = COMMAND_NOTE;
		item._length = (short)length;

		item._param[0] = (short)no;
		item._param[1] = (short)velocity;
		item._param[2] = (short)noteLength;

		return item;

	}

	public int getTime() {
		return _time;
	}

	public byte getChannel() {
		return _channel;
	}

	public byte getCommand() {
		return _command;
	}

	public short getLength() {
		return _length;
	}

	public byte getNoteNo() {
		if (_command == COMMAND_NOTE) {
			return (byte)_param[0];
		} else {
			return 0;
		}
	}

	public byte getVelocity() {
		if (_command == COMMAND_NOTE) {
			return (byte)_param[1];
		} else {
			return 0;
		}
	}

	public short getNoteLength() {
		if (_command == COMMAND_NOTE) {
			return _param[2];
		} else {
			return 0;
		}
	}

	public byte getProgNo() {
		if (_command == COMMAND_PROG) {
			return (byte)_param[0];
		} else {
			return 0;
		}
	}

	public short getParam(int index) {
		return _param[index];
	}

	public boolean setTime(int time) {

		if (time < 0) {
			return false;
		}

		_time = time;

		return true;

	}

	public boolean setChannel(int ch) {

		if (ch < 0 || ch > 3) {
			return false;
		}

		_channel = (byte)ch;

		return true;

	}

	public boolean setCommand(int cmd) {

		if (cmd < 0 || cmd > 127) {
			return false;
		}

		_command = (byte)cmd;

		return true;

	}

	public boolean setLength(int length) {

		if ((_command != COMMAND_NOTE && _command != COMMAND_REST) || length < 0 || length > 32767) {
			return false;
		}

		_length = (short)length;

		return true;

	}

	public boolean setNoteNo(int no) {

		if (_command != COMMAND_NOTE || no < 0 || no > 127) {
			return false;
		}

		_param[0] = (short)no;

		return true;

	}

	public boolean setVelocity(int velocity) {

		if (_command != COMMAND_NOTE || velocity < 0 || velocity > 127) {
			return false;
		}

		_param[1] = (short)velocity;

		return true;

	}

	public boolean setNoteLength(int length) {

		if (_command != COMMAND_NOTE || length < 0 || length > 32767) {
			return false;
		}

		_param[2] = (short)length;

		return true;

	}

	public boolean setProgNo(int no) {

		if (_command != COMMAND_PROG || no < 0 || no > 127) {
			return false;
		}

		_param[0] = (short)no;

		return true;

	}

	public boolean setParam(int index, short val) {

		if (index < 0 || index >= _param.length) {
			return false;
		}

		_param[index] = val;

		return true;

	}

}

// `l̃R}hێgbNNX
class ukMelodyTrack {

	public ukMelodyCommand[] _items;
	public int _capacity;
	public int _index;
	public int[] _channelTime;

	private static final int DEFAULT_CAPACITY = 1024;

	public ukMelodyTrack() {

		_channelTime = new int[4];

		_items = new ukMelodyCommand[DEFAULT_CAPACITY];

		if (_items == null) {
			return;
		}

		_capacity = DEFAULT_CAPACITY;

	}

	/**
	w`lɃR}hǉ

	@param ch `lԍ
	@param item ǉR}h

	@return trueAsfalse
	*/
	public boolean addItem(int ch, ukMelodyCommand item) {

		if (ch < 0 || ch > 3 || item == null) {
			return false;
		}

		if (_index >= _capacity) {

			int capacity = _capacity * 2;

			ukMelodyCommand[] items = new ukMelodyCommand[capacity];

			if (items == null) {
				return false;
			}

			for (int i = 0;i < _index;i++) {
				items[i] = _items[i];
			}

			_items = items;

		}

		ukMelodyCommand mi = new ukMelodyCommand(item);

		mi.setChannel(ch);
		mi.setTime(_channelTime[ch]);

		_items[_index++] = mi;

		_channelTime[ch] += mi.getLength();

		return true;

	}

	/**
	e|ύX

	@param ch `lԍ
	@param tempo e|

	@return trueAsfalse
	*/
	public boolean setTempo(int ch, int tempo) {

		if (tempo < 20 || tempo > 255) {
			return false;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_TEMPO);
		item.setParam(0, (short)tempo);

		return addItem(ch, item);

	}

	/**
	}X^[{[ύX

	@param ch `lԍ
	@param vol {[

	@return trueAsfalse
	*/
	public boolean setMasterVolume(int ch, int vol) {

		if (vol < 0 || vol > 127) {
			return false;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_MASTER_VOL);
		item.setParam(0, (short)vol);

		return addItem(ch, item);

	}

	/**
	`l{[ύX

	@param ch `lԍ
	@param vol {[

	@return trueAsfalse
	*/
	public boolean setChannelVolume(int ch, int vol) {

		if (vol < 0 || vol > 127) {
			return false;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_VOL);
		item.setParam(0, (short)vol);

		return addItem(ch, item);

	}

	/**
	xVeBύX

	@param ch `lԍ
	@param vel xVeB

	@return trueAsfalse
	*/
	public boolean setVelocity(int ch, int vel) {

		if (vel < 0 || vel > 127) {
			return false;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_VELOCITY);
		item.setParam(0, (short)vel);

		return addItem(ch, item);

	}

	/**
	FύXivO`FWjǉ

	@param ch `lԍ
	@param prog Fԍ

	@return trueAsfalse
	*/
	public boolean changeProg(int ch, int prog) {

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_PROG);
		item.setProgNo(prog);

		return addItem(ch, item);

	}

	/**
	im[gI^m[gItjǉ

	@param ch `lԍ
	@param no m[gԍ
	@param velocity ̋
	@param length R}hŜ̎
	@param noteLength 

	@return trueAsfalse
	*/
	public boolean addNote(int ch, int no, int velocity, int length, int noteLength) {

		ukMelodyCommand item = ukMelodyCommand.createNoteItem(no, velocity, length, noteLength);

		return addItem(ch, item);

	}

	/**
	xǉ

	@param ch `lԍ
	@param length 

	@return trueAsfalse
	*/
	public boolean addRest(int ch, int length) {

		if (length < 1) {
			return false;
		}

		ukMelodyCommand item = new ukMelodyCommand();

		item.setCommand(ukMelodyCommand.COMMAND_REST);
		item.setLength(length);

		return addItem(ch, item);

	}

	/**
	ێĂR}hz񂩂SMFgbNf[^쐬

	@return SMF`̃gbNf[^Bf[^쐬łȂnull
	*/
	public byte[] getSMFTrack() {

		if (_index < 1) {
			return null;
		}

		Vector tmpArray = new Vector();

		ukMelodyCommand item = new ukMelodyCommand();

		// R}hm[gI^m[gItōč\
		for (int i = 0;i < _index;i++) {

			item.assign(_items[i]);

			switch (item.getCommand()) {

			case ukMelodyCommand.COMMAND_PROG:
			case ukMelodyCommand.COMMAND_MASTER_VOL:
			case ukMelodyCommand.COMMAND_VOL:
			case ukMelodyCommand.COMMAND_VELOCITY:
			case ukMelodyCommand.COMMAND_TEMPO:

				tmpArray.addElement(new ukMelodyCommand(item));

				break;

			case ukMelodyCommand.COMMAND_NOTE:

				// m[gIR}h
				tmpArray.addElement(new ukMelodyCommand(item));

				// m[gItR}h
				item.setTime(item.getTime() + _items[i].getNoteLength());
				item.setVelocity(0);

				tmpArray.addElement(new ukMelodyCommand(item));

				break;

			}

		}

		ukMelodyCommand[] items = new ukMelodyCommand[tmpArray.size()];

		for (int i = 0;i < items.length;i++) {
			items[i] = (ukMelodyCommand)tmpArray.elementAt(i);
		}

		ByteArrayOutputStream buf = new ByteArrayOutputStream();

		int time = 0;

		while (true) {

			int nexttime = 0x7fffffff;
			int nextindex = -1;

			// ɏ鎞ԍŏ̃R}h
			for (int i = 0;i < items.length;i++) {
				if (items[i] != null && items[i].getTime() < nexttime) {

					nexttime = items[i].getTime();
					nextindex = i;

				}
			}

			// m[gR}hȊOD
			for (int i = 0;i < _index;i++) {
				if (items[i] != null && items[i].getTime() == nexttime) {
					if (items[i].getCommand() != ukMelodyCommand.COMMAND_NOTE) {
						nextindex = i;
					}
				}
			}

			// }X^[{[ŗD
			for (int i = 0;i < _index;i++) {
				if (items[i] != null && items[i].getTime() == nexttime) {
					if (items[i].getCommand() == ukMelodyCommand.COMMAND_MASTER_VOL) {
						nextindex = i;
					}
				}
			}

			if (nextindex < 0) {
				break;
			}

			// 񏈗R}h̎ԂƑO񏈗̎Ԃf^^CZo
			int dtime = items[nextindex].getTime() - time;

			// f^^Cϒ\
			byte[] dtimes = getNumBytes(dtime);

			switch (items[nextindex].getCommand()) {

			// e|ݒ
			case ukMelodyCommand.COMMAND_TEMPO:

				for (int i = 0;i < dtimes.length;i++) {
					buf.write(dtimes[i]);
				}

				int microsec = 60000000 / items[nextindex].getParam(0);

				buf.write((byte)0xff);
				buf.write((byte)0x51);
				buf.write((byte)3);
				buf.write((byte)((microsec >> 16) & 0xff));
				buf.write((byte)((microsec >> 8) & 0xff));
				buf.write((byte)(microsec & 0xff));

				break;

			// }X^[ʐݒ
			case ukMelodyCommand.COMMAND_MASTER_VOL:

				for (int i = 0;i < dtimes.length;i++) {
					buf.write(dtimes[i]);
				}

				buf.write((byte)0xf0);
				buf.write((byte)0x41);
				buf.write((byte)0x10);
				buf.write((byte)0x42);
				buf.write((byte)0x12);
				buf.write((byte)0x40);
				buf.write((byte)0x00);
				buf.write((byte)0x04);

				byte mvol = (byte)(items[nextindex].getParam(0) & 0x7f);

				buf.write(mvol);

				buf.write((byte)0x4c);
				buf.write((byte)0xf7);

				break;

			// `l{[ݒ
			case ukMelodyCommand.COMMAND_VOL:

				for (int i = 0;i < dtimes.length;i++) {
					buf.write(dtimes[i]);
				}

				byte vol = (byte)(items[nextindex].getParam(0) & 0x7f);

				buf.write((byte)(0xb0 | (items[nextindex].getChannel() & 0x0f)));
				buf.write((byte)0x07);
				buf.write((byte)vol);

				break;

			// vO`FW
			case ukMelodyCommand.COMMAND_PROG:

				byte cmdProg = (byte)((0xC0 | ((items[nextindex].getChannel()) & 0x0f)) & 0xff);

				for (int i = 0;i < dtimes.length;i++) {
					buf.write(dtimes[i]);
				}

				buf.write(cmdProg);
				buf.write((byte)(items[nextindex].getProgNo()));

				break;

			// m[gI^m[gIt
			case ukMelodyCommand.COMMAND_NOTE:

				byte cmdNote = 0;

				cmdNote = (byte)((0x90 | ((items[nextindex].getChannel()) & 0x0f)) & 0xff);

				byte no = (byte)(items[nextindex].getNoteNo() & 0x7f);
				byte velocity = (byte)(items[nextindex].getVelocity() & 0x7f);

				// R}h
				try {

					for (int i = 0;i < dtimes.length;i++) {
						buf.write(dtimes[i]);
					}

					buf.write(cmdNote);
					buf.write(no);
					buf.write(velocity);

				} catch (Exception e) {
				}

				break;

			case ukMelodyCommand.COMMAND_REST:

				break;

			}

			time += dtime;

			// 񏈗R}hnull
			items[nextindex] = null;

		}

		// gbNI[
		try {

			buf.write(0);
			buf.write(0xff);
			buf.write(0x2f);
			buf.write(0);

		} catch (Exception e) {
		}

		byte[] data = null;

		// obt@zɏo
		try {
			data = buf.toByteArray();
		} catch (Exception e) {
		}

		return data;

	}

	/**
	ێĂR}hz񂩂mldgbNf[^쐬

	@return mld`̃gbNf[^Bf[^쐬łȂnull
	*/
	public byte[] getMLDTrack() {

		if (_index < 1) {
			return null;
		}

		Vector tmpArray = new Vector();

		ukMelodyCommand item = new ukMelodyCommand();

		// R}hč\
		for (int i = 0;i < _index;i++) {

			item.assign(_items[i]);

			switch (item.getCommand()) {

			case ukMelodyCommand.COMMAND_VOL:
			case ukMelodyCommand.COMMAND_PROG:
			case ukMelodyCommand.COMMAND_TEMPO:

				tmpArray.addElement(new ukMelodyCommand(item));

				break;

			case ukMelodyCommand.COMMAND_NOTE:

				if (item.getNoteLength() < 256) {
					tmpArray.addElement(new ukMelodyCommand(item));
				} else {


				}

				break;

			}

		}

		ukMelodyCommand[] items = new ukMelodyCommand[_index];

		for (int i = 0;i < _index;i++) {
			items[i] = new ukMelodyCommand(_items[i]);
		}

		ByteArrayOutputStream buf = new ByteArrayOutputStream();

		int time = 0;

		while (true) {

			int nexttime = 0x7fffffff;
			int nextindex = -1;

			// ɏ鎞ԍŏ̃R}h
			for (int i = 0;i < _index;i++) {
				if (items[i] != null && items[i].getTime() < nexttime) {

					nexttime = items[i].getTime();
					nextindex = i;

				}
			}

			for (int i = 0;i < _index;i++) {
				if (items[i] != null && items[i].getTime() == nexttime) {
					if (items[i].getCommand() != ukMelodyCommand.COMMAND_NOTE) {
						nextindex = i;
					}
				}
			}

			if (nextindex < 0) {
				break;
			}

			// 񏈗R}h̎ԂƑO񏈗̎Ԃf^^CZo
			int dtime = items[nextindex].getTime() - time;

			// bZ[W𑗂`lݒ
			byte ch = (byte)(((items[nextindex].getChannel() & 0xff) << 6) & 0xff);

			switch (items[nextindex].getCommand()) {

			// e|ݒ
			case ukMelodyCommand.COMMAND_TEMPO:

				buf.write(dtime);
				buf.write(0xff);
				buf.write(0xC3);

				byte tempo = (byte)(items[nextindex].getParam(0) & 0xff);

				buf.write(tempo);

				break;

			// `lʐݒ
			case ukMelodyCommand.COMMAND_VOL:

				buf.write(dtime);
				buf.write(0xff);
				buf.write(0xe2);

				byte vol = (byte)(ch | ((items[nextindex].getParam(0) / 2) & 0x3f));

				buf.write(vol);

				break;

			// vO`FW
			case ukMelodyCommand.COMMAND_PROG:

				buf.write(dtime);
				buf.write(0xff);
				buf.write(0xe0);

				byte prog1 = (byte)(items[nextindex].getProgNo() & 0x3f);

				buf.write((byte)(ch | prog1));

				buf.write(0);
				buf.write(0xff);
				buf.write(0xe1);

				byte prog2 = 0;

				if (items[nextindex].getProgNo() > 63) {
					prog2 = 3;
				} else {
					prog2 = 2;
				}

				buf.write((byte)(ch | prog2));

				break;

			// 
			case ukMelodyCommand.COMMAND_NOTE:

				int no = items[nextindex].getNoteNo();
				byte velocity = (byte)(items[nextindex].getVelocity() & 0xff);
				byte length = (byte)(items[nextindex].getNoteLength() & 0xff);

				// MIDĨm[gԍmld̃m[gԍ
				no -= 33;

				// IN^[uVtg
				byte os = 0;

				// IN^[uVtgݒiMIDIm[gԍ21j
				if (no < 0) {
					if (no >= -12) {

						os = 1;

						no += 12;

					}
				}

				// IN^[uVtgݒiMIDIm[gԍ119j
				if (no > 0x3e) {
					if ((no - 0x3e) < 24) {
						if ((no - 0x3e) < 12) {

							no -= 12;
							os = 3;

						} else {

							no -= 24;
							os = 2;

						}
					}
				}

				byte noteNo = (byte)((byte)(ch & 0xff) | (byte)(no & 0x7f));

				// MIDĨxVeBi7rbgjmld̃xVeBi6rbgj
				velocity /= 2;

				byte st2 = (byte)((((velocity & 0xff) << 2) & 0xff) | os);

				try {

					buf.write(dtime);
					buf.write(noteNo);
					buf.write(length);
					buf.write(st2);

				} catch (Exception e) {
				}

				break;

			}

			time += dtime;

			// 񏈗R}hnull
			items[nextindex] = null;

		}

		try {

			buf.write(0x00);
			buf.write(0xff);
			buf.write(0xdf);
			buf.write(0);

		} catch (Exception e) {
		}

		byte[] data = null;

		try {
			data = buf.toByteArray();
		} catch (Exception e) {
		}

		return data;

	}

	/**
	f^^CȂMIDIf[^p8i7jrbgϒl\擾

	@param val ϊl
	@return ϊ
	*/
	private byte[] getNumBytes(int val) {

		int bit = 0;

		// rbgZo
		for (int i = 0;i < 30;i++) {
			if ((val & ((1 << i))) != 0) {
				bit = i + 1;
			}
		}

		int size = 1;

		if (bit > 0) {
			size = 1 + ((bit - 1) / 7);
		}

		byte[] bytes = new byte[size];

		for (int i = bytes.length - 1 ;i >= 0;i--) {

			bytes[i] = (byte)((val & 0x7f) & 0xff);
			val = val >> 7;

			if (i != bytes.length - 1) {
				bytes[i] |= (byte)0x80;
			}

		}

		return bytes;

	}

}

public class ukMusicData {

	private ukMelodyTrack _track;

	private String _title;
	private String _copyright;

	public ukMusicData() {
		initTrack();
	}

	public void initTrack() {

		_track = new ukMelodyTrack();

	}

	public ukMelodyTrack getTrack() {
		return _track;
	}

	/*
	ێĂgbNSMF`̃oCif[^쐬

	@return SMF`̃oCif[^
	*/
	public byte[] getSMF() {

		if (_track == null) {
			return null;
		}

		byte[] smf = null;

		byte[] header = null;
		byte[] track = null;

		ByteArrayOutputStream infobuf = new ByteArrayOutputStream();

		try {

			infobuf.write("MThd".getBytes());

			// wb_TCY6
			infobuf.write(0);
			infobuf.write(0);
			infobuf.write(0);
			infobuf.write(6);

			// tH[}bg0
			infobuf.write(0);
			infobuf.write(0);

			// gbN1
			infobuf.write(0);
			infobuf.write(1);

			// l̒48
			infobuf.write(0);
			infobuf.write(0x30);

			header = infobuf.toByteArray();

		} catch (Exception e){}

		// gbNf[^擾
		byte[] trackData = _track.getSMFTrack();

		if (trackData == null || trackData.length < 1) {
			return null;
		}

		ByteArrayOutputStream trackbuf = new ByteArrayOutputStream();

		try {

			trackbuf.write("MTrk".getBytes());

			// f[^TCY0Ŗ߂
			trackbuf.write(0);
			trackbuf.write(0);
			trackbuf.write(0);
			trackbuf.write(0);

			// gbNf[^
			trackbuf.write(trackData);

			track = trackbuf.toByteArray();

		} catch (Exception e){}

		if (track == null) {
			return null;
		}

		// gbÑf[^TCY
		track[7] = (byte)((trackData.length & 0x000000ff) & 0xff);
		track[6] = (byte)(((trackData.length & 0x0000ff00) >> 8) & 0xff);
		track[5] = (byte)(((trackData.length & 0x00ff0000) >> 16) & 0xff);
		track[4] = (byte)(((trackData.length & 0xff000000) >> 24) & 0xff);

		ByteArrayOutputStream smfbuf = new ByteArrayOutputStream();

		try {

			smfbuf.write(header);
			smfbuf.write(track);

			smf = smfbuf.toByteArray();

		} catch (Exception e){}

		return smf;

	}

	/*
	ێĂgbNmld`̃oCif[^쐬

	@return mld`̃oCif[^
	*/
	public byte[] getMLD() {

		if (_track == null) {
			return null;
		}

		byte[] header = new byte[13];
		byte[] info = null;
		byte[] trackhead = new byte[8];
		byte[] track = null;

		ByteArrayOutputStream infobuf = new ByteArrayOutputStream();

		try {

			byte[] name = "test".getBytes();

			infobuf.write("titl".getBytes());
			infobuf.write((byte)((name.length & 0xff00) >> 8));
			infobuf.write((byte)(name.length & 0xff));
			infobuf.write(name);

			infobuf.write("vers".getBytes());
			infobuf.write(0);
			infobuf.write(4);
			infobuf.write(0x30);
			infobuf.write(0x33);
			infobuf.write(0x31);
			infobuf.write(0x30);

			infobuf.write("sorc".getBytes());
			infobuf.write(0);
			infobuf.write(1);
			infobuf.write(0);

			infobuf.write("note".getBytes());
			infobuf.write(0);
			infobuf.write(2);
			infobuf.write(0);
			infobuf.write(1);

			infobuf.close();

			info = infobuf.toByteArray();

		} catch (Exception e){}

		track = _track.getMLDTrack();

		int trackLength = track.length;

		trackhead[0] = 0x74;
		trackhead[1] = 0x72;
		trackhead[2] = 0x61;
		trackhead[3] = 0x63;

		trackhead[7] = (byte)((trackLength & 0x000000ff) & 0xff);
		trackhead[6] = (byte)(((trackLength & 0x0000ff00) >> 8) & 0xff);
		trackhead[5] = (byte)(((trackLength & 0x00ff0000) >> 16) & 0xff);
		trackhead[4] = (byte)(((trackLength & 0xff000000) >> 24) & 0xff);

		header[0] = 0x6d;
		header[1] = 0x65;
		header[2] = 0x6c;
		header[3] = 0x6f;

		int dataLength = 13 + info.length + track.length;

		// f[^
		header[7] = (byte)((dataLength - 8) & 0xff);
		header[6] = (byte)((((dataLength - 8) & 0x0000ff00) >> 8) & 0xff);
		header[5] = (byte)((((dataLength - 8) & 0x00ff0000) >> 16) & 0xff);
		header[4] = (byte)((((dataLength - 8) & 0xff000000) >> 24) & 0xff);

		int trackOffset = info.length + 3;

		// gbN܂ł̃ItZbg
		header[9] = (byte)(trackOffset & 0xff);
		header[8] = (byte)(((trackOffset & 0x0000ff00) >> 8) & 0xff);

		// f[^^Cv
		header[10] = 2;
		header[11] = 1;

		// gbN
		header[12] = 1;

		ByteArrayOutputStream mldbuf = new ByteArrayOutputStream();
		byte[] mld = null;

		try {

			mldbuf.write(header);
			mldbuf.write(info);
			mldbuf.write(trackhead);
			mldbuf.write(track);

			mldbuf.close();

			mld = mldbuf.toByteArray();

		} catch (Exception e){}

		return mld;

	}

	public boolean setMML(String mml) {

		if (mml == null || mml.length() < 1) {
			return false;
		}

		// +-tm[gwꕶ̏At@xbgɒu
		String src = replace(mml, "c+", "i");
		src = replace(src, "c", "h");
		src = replace(src, "d-", "i");
		src = replace(src, "d+", "k");
		src = replace(src, "d", "j");
		src = replace(src, "e-", "k");
		src = replace(src, "e", "l");
		src = replace(src, "f+", "n");
		src = replace(src, "f", "m");
		src = replace(src, "g-", "n");
		src = replace(src, "g+", "p");
		src = replace(src, "g", "o");
		src = replace(src, "a-", "p");
		src = replace(src, "a+", "r");
		src = replace(src, "a", "q");
		src = replace(src, "b-", "r");
		src = replace(src, "b", "s");

		// m[gwȊO̊eR}hꕶ̑啶At@xbgɒu
		src = replace(src, "!T", "T"); // e|w
		src = replace(src, "!C", "C"); // `lw
		src = replace(src, "@I", "I"); // Fw
		src = replace(src, "@V", "V"); // `lʎw
		src = replace(src, "@E", "E"); // xVeBw
		src = replace(src, "@L", "L"); // w
		src = replace(src, "@Q", "Q"); // w
		src = replace(src, "@O", "O"); // IN^[uw
		src = replace(src, ">", "A1"); // IN^[u
		src = replace(src, "<", "B1"); // IN^[uグ

		// mmlm[gwAR}hAp[^l̃g[Nɕ
		String[] tokens = getToken(src);

		int ch = -1;

		int[] prog = new int[4];
		int[] volume = new int[4];
		int[] velocity = new int[4];
		int[] length = new int[4];
		int[] qtime = new int[4];
		int[] noteLength = new int[4];
		int[] octave = new int[4];

		// e`lp[^ݒ
		for (int i = 0;i < 4;i++) {

			prog[i] = 0;
			volume[i] = 100;
			velocity[i] = 100;
			length[i] = 48;
			qtime[i] = 90;
			noteLength[i] = (length[i] * qtime[i]) / 100;
			octave[i] = 4;

		}

		int index = 0;

		String prev = null;

		// ꂽg[Nz񂩂R}hz쐬
		while (index < tokens.length) {

			String item = tokens[index].substring(1);

			switch (tokens[index].charAt(0)) {

			case '1': // 

				if (prev == null || prev.length() != 1) {
					return false;
				}

				switch (prev.charAt(0)) { // R}hɉď

				case 'T': // e|ؑ

					_track.setTempo(ch, Integer.parseInt(item));

					break;

				case 'C': // `lؑ

					ch = Integer.parseInt(item);

					break;

				case 'V': // `l

					_track.setChannelVolume(ch, Integer.parseInt(item));

					break;

				case 'E': // xVeB

					velocity[ch] = Integer.parseInt(item);

					break;

				case 'I': // Fؑ

					prog[ch] = Integer.parseInt(item);

					_track.changeProg(ch, prog[ch]);

					break;

				case 'L': // w

					length[ch] = Integer.parseInt(item);
					noteLength[ch] = (length[ch] * qtime[ch]) / 100;

					break;

				case 'Q': // Ԏw

					qtime[ch] = Integer.parseInt(item);
					noteLength[ch] = (length[ch] * qtime[ch]) / 100;

					break;

				case 'O': // IN^[uw

					octave[ch] = Integer.parseInt(item);

					break;

				case 'A': // IN^[u

					octave[ch] -= Integer.parseInt(item);

					break;

				case 'B': // IN^[uグ

					octave[ch] += Integer.parseInt(item);

					break;

				}

				break;

			case '2': // 

				// m[gǉ
				for (int j = 0;j < item.length();j++) {

					int note = item.charAt(j) - 'h' + (octave[ch] + 1) * 12;

					_track.addNote(ch, note, velocity[ch], length[ch], noteLength[ch]);

				}

				break;

			case '3': // 啶

				break;

			}

			prev = item;

			index++;

		}

		return true;

	}

	/**
	srckeyvalɒuԂ

	@param src 
	@param key uΏە
	@param val u

	@return uʂ̕Asnull
	*/
	private String replace(String src, String key, String val) {

		if (src == null || src.length() < 1) {
			return null;
		}

		if (key == null || key.length() < 1 || src.length() < key.length()) {
			return new String(src);
		}

		StringBuffer sb = new StringBuffer();

		int index = 0;

		while (index < src.length()) {

			int find = src.indexOf(key, index);

			if (find < 0) {

				sb.append(src.substring(index));

				index = src.length();

			} else {

				sb.append(src.substring(index, find));

				if (val != null && val.length() > 0) {
					sb.append(val);
				}

				index = find + key.length();

			}

		}

		return sb.toString();

	}

	private String[] getToken(String str) {

		Vector items = new Vector();

		int index = 0;
		int prev = 0;

		while (index < str.length()) {

			int type = 0;

			if (str.charAt(index) >= '0' && str.charAt(index) <= '9') {
				type = 1;
			}

			if (str.charAt(index) >= 'h' && str.charAt(index) <= 's') {
				type = 2;
			}

			if (str.charAt(index) >= 'A' && str.charAt(index) <= 'Z') {
				type = 3;
			}

			int start = index;

			switch (type) {

			case 0:

				return null;

			case 1:

				if (prev != 3) {
					return null;
				}

				while (index < str.length() && str.charAt(index) >= '0' && str.charAt(index) <= '9') {
					index++;
				}

				break;

			case 2:

				while (index < str.length() && index < str.length() && str.charAt(index) >= 'a' && str.charAt(index) <= 'z') {
					index++;
				}

				break;

			case 3:

				index++;

				break;

			}

			prev = type;

			if (index > start) {

				String item = str.substring(start, index);

				items.addElement(String.valueOf(type) + item);

			} else {
			}

		}

		String[] tokenArray = new String[items.size()];

		for (int i = 0;i < items.size();i++) {
			tokenArray[i] = (String)items.elementAt(i);
		}

		return tokenArray;

	}

}
